
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>The Tools We Work With &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Thoughts on the eve of Varnish 3.0" href="three-zero.html" />
    <link rel="prev" title="Varnish Does Not Hash" href="varnish_does_not_hash.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="three-zero.html" title="Thoughts on the eve of Varnish 3.0"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="varnish_does_not_hash.html" title="Varnish Does Not Hash"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The Tools We Work With</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="the-tools-we-work-with">
<span id="phk-thetoolsweworkwith"></span><h1>The Tools We Work With<a class="headerlink" href="#the-tools-we-work-with" title="Permalink to this headline">¶</a></h1>
<p>“Only amateurs were limited by their tools” is an old wisdom, and
the world is littered with art and architecture that very much
proves this point.</p>
<p>But as amazing as the Aquaeduct of Segovia is, tools are the reason
why it looks nowhere near as fantastic as the Sydney Opera House.</p>
<p>Concrete has been known since antiquity, but steel-reinforced
concrete and massive numerical calculations of stress-distribution,
is the tools that makes the difference between using concrete as a
filler material between stones, and as gravity-defying curved but
perfectly safe load-bearing wall.</p>
<p>My tool for writing Varnish is the C-language which in many ways
is unique amongst all of the computer programming languages for
having no ambitions.</p>
<p>The C language was invented as a portable assembler language, it
doesn’t do objects and garbage-collection, it does numbers and
pointers, just like your CPU.</p>
<p>Compared to the high ambitions, then as now, of new programming
languages, that was almost ridiculous unambitious.  Other people
were trying to make their programming languages provably correct,
or safe for multiprogramming and quite an effort went into using
natural languages as programming languages.</p>
<p>But C was written to write programs, not to research computer science
and that’s exactly what made it useful and popular.</p>
<p>Unfortunately C fell in bad company over the years, and the reason
for this outburst is that I just browsed the latest draft from the
ISO-C standardisation working-group 14.</p>
<p>I won’t claim that it is enough to make grown men cry, but it
certainly was enough to make me angry.</p>
<p>Let me give you an example of their utter sillyness:</p>
<p>The book which defined the C langauge had a list af reserved
identifiers, all of them lower-case words.  The UNIX libraries
defined a lot of functions, all of them lower-case words.</p>
<p>When compiled, the assembler saw all of these words prefixed
with an underscore, which made it easy to mix assembler and
C code.</p>
<p>All the macros for the C-preprocessor on the other hand, were
UPPERCASE, making them easy to spot.</p>
<p>Which meant that if you mixed upper and lower case, in your
identifiers, you were safe: That wouldn’t collide with anything.</p>
<p>First the ISO-C standards people got confused about the leading
underscore, and I’ll leave you guessing as to what the current
text actually means:</p>
<blockquote>
<div><p>All identifiers that begin with an underscore and either
an uppercase letter or another underscore are always reserved
for any use.</p>
</div></blockquote>
<p>Feel free to guess, there’s more such on pdf page 200 of the draft.</p>
<p>Next, they broke the upper/lower rule, by adding special keywords
in mixed case, probably because they thought it looked nicer:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">_Atomic</span><span class="p">,</span> <span class="n">_Bool</span><span class="p">,</span> <span class="n">_Noreturn</span> <span class="o">&amp;</span><span class="n">c</span>
</pre></div>
</div>
<p>Then, presumably, somebody pointed out that this looked ugly:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">void</span> <span class="n">_Noreturn</span> <span class="n">foo</span><span class="p">(</span><span class="nb">int</span> <span class="n">bar</span><span class="p">);</span>
</pre></div>
</div>
<p>So they have come up with a #include file called &lt;stdnoreturn.h&gt;
so that instead you can write:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1">#include &lt;nostdreturn.h&gt;</span>
<span class="n">void</span> <span class="n">noreturn</span> <span class="n">foo</span><span class="p">(</span><span class="nb">int</span> <span class="n">bar</span><span class="p">);</span>
</pre></div>
</div>
<p>The &lt;nostdreturn.h&gt; file according to the standard shall have
exactly this content:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1">#define noreturn _Noreturn</span>
</pre></div>
</div>
<p>Are you crying or laughing yet ?   You should be.</p>
<p>Another thing brought by the new draft is an entirely new thread
API, which is incompatible with the POSIX ‘pthread’ API which have
been used for about 20 years now.</p>
<p>If they had improved on the shortcomings of the pthreads, I would
have cheered them on, because there are some very annoying mistakes
in pthreads.</p>
<p>But they didn’t, in fact, as far as I can tell, the C1X draft’s
threads are worse than the 20 years older pthreads in all relevant
aspects.</p>
<p>For instance, neither pthreads nor C1X-threads offer a “assert I’m
holding this mutex locked” facility.  I will posit that you cannot
successfully develop real-world threaded programs and APIs without
that, or without wasting a lot of time debugging silly mistakes.</p>
<p>If you look in the Varnish source code, which uses pthreads, you
will see that I have wrapped pthread mutexes in my own little
datastructure, to be able to do those asserts, and to get some
usable statistics on lock-contention.</p>
<p>Another example where C1X did not improve on pthreads at all, was
in timed sleeps, where you say “get me this lock, but give up if
it takes longer than X time”.</p>
<p>The way both pthreads and C1X threads do this, is you specify a UTC
wall clock time you want to sleep until.</p>
<p>The only problem with that is that UTC wall clock time is not
continuous when implemented on a computer, and it may not even be
monotonously increasing, since NTPD or other timesync facilites may
step the clock backwards, particularly in the first minutes after
boot.</p>
<p>If the practice of saying “get me this lock before 16:00Z” was
widespread, I could see the point, but I have actually never seen
that in any source code.  What I have seen are wrappers that take
the general shape of:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="nb">int</span>
<span class="n">get_lock_timed</span><span class="p">(</span><span class="n">lock</span><span class="p">,</span> <span class="n">timeout</span><span class="p">)</span>
<span class="p">{</span>
        <span class="k">while</span> <span class="p">(</span><span class="n">timeout</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">)</span> <span class="p">{</span>
                <span class="n">t0</span> <span class="o">=</span> <span class="n">time</span><span class="p">();</span>
                <span class="n">i</span> <span class="o">=</span> <span class="n">get_lock_before</span><span class="p">(</span><span class="n">lock</span><span class="p">,</span> <span class="n">t</span> <span class="o">+</span> <span class="n">timeout</span><span class="p">));</span>
                <span class="k">if</span> <span class="p">(</span><span class="n">i</span> <span class="o">==</span> <span class="n">WASLOCKED</span><span class="p">)</span>
                        <span class="k">return</span> <span class="p">(</span><span class="n">i</span><span class="p">);</span>
                <span class="n">t1</span> <span class="o">=</span> <span class="n">time</span><span class="p">();</span>
                <span class="n">timeout</span> <span class="o">-=</span> <span class="p">(</span><span class="n">t1</span> <span class="o">-</span> <span class="n">t0</span><span class="p">);</span>
        <span class="p">}</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">TIMEDOUT</span><span class="p">);</span>
<span class="p">}</span>
</pre></div>
</div>
<p>Because it’s not like the call is actually guaranteed to return at
16:00Z if you ask it to, you are only promised it will not return
later than that, so you have to wrap the call in a loop.</p>
<p>Whoever defined the select(2) and poll(2) systemcalls knew better
than the POSIX and ISO-C group-think:  They specified a maximum
duration for the call, because then it doesn’t matter what time
it is, only how long time has transpired.</p>
<p>Ohh, and setting the stack-size for a new thread ?
That is apparently “too dangerous” so there is no argument in the
C1X API for doing so, a clear step backwards from pthreads.</p>
<p>But guess what:  Thread stacks are like T-shirts:  There is no “one
size fits all.”</p>
<p>I have no idea what the “danger” they perceived were, my best
guess is that feared it might make the API useful ?</p>
<p>This single idiocy will single-handedly doom the C1X thread API
to uselessness.</p>
<p>Now, don’t get me wrong:  There are lot of ways to improve the C
language that would make sense:  Bitmaps, defined structure packing
(think: communication protocol packets), big/little endian variables
(data sharing), sensible handling of linked lists etc.</p>
<p>As ugly as it is, even the printf()/scanf() format strings could
be improved, by offering a sensible plugin mechanism, which the
compiler can understand and use to issue warnings.</p>
<p>Heck, even a simple basic object facility would be good addition,
now that C++ have become this huge bloated monster language.</p>
<p>But none of that is apparently as important as &lt;stdnoreturn.h&gt;
and a new, crippled and therefore useless thread API.</p>
<p>The neat thing about the C language, and the one feature that made
it so popular, is that not even an ISO-C working group can prevent
you from implementing all these things using macros and other tricks.</p>
<p>But it would be better to have them in the language, so the compiler
could issue sensible warnings and programmers won’t have to write
monsters like:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1">#define VTAILQ_INSERT_BEFORE(listelm, elm, field) do {              \</span>
    <span class="p">(</span><span class="n">elm</span><span class="p">)</span><span class="o">-&gt;</span><span class="n">field</span><span class="o">.</span><span class="n">vtqe_prev</span> <span class="o">=</span> <span class="p">(</span><span class="n">listelm</span><span class="p">)</span><span class="o">-&gt;</span><span class="n">field</span><span class="o">.</span><span class="n">vtqe_prev</span><span class="p">;</span>            \
    <span class="n">VTAILQ_NEXT</span><span class="p">((</span><span class="n">elm</span><span class="p">),</span> <span class="n">field</span><span class="p">)</span> <span class="o">=</span> <span class="p">(</span><span class="n">listelm</span><span class="p">);</span>                          \
    <span class="o">*</span><span class="p">(</span><span class="n">listelm</span><span class="p">)</span><span class="o">-&gt;</span><span class="n">field</span><span class="o">.</span><span class="n">vtqe_prev</span> <span class="o">=</span> <span class="p">(</span><span class="n">elm</span><span class="p">);</span>                            \
    <span class="p">(</span><span class="n">listelm</span><span class="p">)</span><span class="o">-&gt;</span><span class="n">field</span><span class="o">.</span><span class="n">vtqe_prev</span> <span class="o">=</span> <span class="o">&amp;</span><span class="n">VTAILQ_NEXT</span><span class="p">((</span><span class="n">elm</span><span class="p">),</span> <span class="n">field</span><span class="p">);</span>        \
<span class="p">}</span> <span class="k">while</span> <span class="p">(</span><span class="mi">0</span><span class="p">)</span>
</pre></div>
</div>
<p>To put an element on a linked list.</p>
<p>I could go on like this, but it would rapidly become boring for
both you and me, because the current C1X draft is 701 pages, and
it contains not a single explanatory example if how to use any of
the verbiage in practice.</p>
<p>Compare this with The C Programming Language, a book of 274 pages
which in addition to define the C language, taught people how to
program through well-thought-out examples.</p>
<p>From where I sit, ISO WG14 are destroying the C language I use and love.</p>
<p>Poul-Henning, 2011-12-20</p>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="varnish_does_not_hash.html"
                        title="previous chapter">Varnish Does Not Hash</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="three-zero.html"
                        title="next chapter">Thoughts on the eve of Varnish 3.0</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/phk/thetoolsweworkwith.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="three-zero.html" title="Thoughts on the eve of Varnish 3.0"
             >next</a> |</li>
        <li class="right" >
          <a href="varnish_does_not_hash.html" title="Varnish Does Not Hash"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The Tools We Work With</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>